const request = require('request')

exports.httpReq = (ctx, opts) => {
  opts.timeout = opts.timeout || 1000
  return new Promise((resolve, reject) => {
    var time_start = +new Date()
    opts.qs = {...ctx.request.query, ...opts.qs};

    request(opts, (err, res, body) => {
      console.info(`[Api] httpReq (${opts.url},${opts.headers && opts.headers.cookie}, user:[${opts.qs.op_cur_user}]) spent: ${+new Date() - time_start}ms`)

      if (!err) {
        resolve(body)
      } else {
        reject(err)
        console.error(opts.url, err)
      }
    })
  })
}
